# Date: 11.01.2021
from vcCommand import *
import vcHelpers.Selection as selhelp
import re

app = getApplication()
cmd = getCommand()

def first_state():
  sm = app.SelectionManager
  if app.CurrentContext == app.AuthorContext:
    selected_comps = [app.AuthorContext.ActiveComponent]
  else:
    selected_comps = sm.getSelection(VC_SELECTION_COMPONENT)
    
  if not selected_comps:
    print 'Select at least one component first.'
    return

  count = 0
  all_geos = selhelp.filterFeatures(selhelp.getAllComponentsFeatures(), VC_GEOMETRY)
  for comp in selected_comps:
    for fea in selhelp.filterFeatures(selhelp.getGivenComponentsFeatures(comp), VC_GEOMETRY):
      orig_name = fea.Name
      fea.Name = get_unique_name(fea, all_geos)
      if fea.Name != orig_name:
        print comp.Name + '::' + orig_name, '==>', fea.Name
        count += 1
  print 'Renamed total of', count ,'geometries'

def get_unique_name(fea, all_geos):
  # type: (vcGeometryFeature, List[vcGeometryFeature]) -> str
  uniq_name = fea.Name # fea.Name.rsplit()
  while any(g != fea and g.Name == uniq_name for g in all_geos):
    m = re.search(r'_\d+$', uniq_name) # test for a number suffix
    if m:
      old_num = m.group()[1:]
      new_num = str(int(old_num) + 1)
      reverse_replace = uniq_name.rsplit(old_num, 1)
      uniq_name = new_num.join(reverse_replace)
    else:
      uniq_name += '_1'
  return uniq_name

def get_geometries(sel_comp):
  # type: (vcComponent) -> List[vcGeometryFeature]
  all_feas = []
  for comp_feas in (selhelp.filterFeatures(selhelp.getGivenComponentsFeatures(c), VC_GEOMETRY) for c in app.Components if c != sel_comp):
    all_feas.extend(comp_feas)
  return all_feas

addState(first_state)

